(*
              A full pallete unit, made just 4 U, by dark-cloud.







                           Programmed by dark-cloud








dark-cloud programming.
*)

Unit Pallete;

Interface

Const
  R = 0;
  G = 1;
  B = 2;

Type
  Paltype           = Array [ 0..255 , 0..2 ] Of Byte;

Var
  Pall              : PalType;

{ Set the color number Col pallete to R, G, and B }
Procedure Pal(Col,R,G,B : Byte);
{ Gets the current pallete into Pal }
Procedure GetAllPal(Pallete : PalType);
{ Sets Pal to the current pallete }
Procedure SetAllPal(Pallete : Paltype);
{ Loads pal file named F into Pal }
Procedure LoadPal(Fn : String; Pallete : PalType );
{ Fades to pallete Pal }
Procedure Fade2Pal( StartPal, EndPal, D : Word; Pallete : Paltype);
{ Fades the current pallete but maximum 1 step }
Function OneStepFade( StartPal, EndPal : Word; var CurrPal : PalType; Pallete : Paltype) : Boolean;
{ Fades the current pallete to PALLETE, but all colors arrives together. }
Procedure StepFade( StartPal, EndPal, D, MaxTimes : Word; Pallete : PalType );
{ Fills Pal with the RGB given pallete }
Procedure FillPalType(R,G,B : Word; Var Pallete : PalType);
{ Sets the colors in the given pallete to gray GVANIM }
Procedure SetGrayPal(StartPal, EndPal : Byte; Var Pallete : PalType);
{ Sets the colors in the given pallete to red GVANIM }
Procedure SetRedPal(StartPal, EndPal : Byte; Var Pallete : PalType);
{ Sets the colors in the given pallete to green GVANIM }
Procedure SetGreenPal(StartPal, EndPal : Byte; Var Pallete : PalType);
{ Sets the colors in the given pallete to blue GVANIM }
Procedure SetBluePal(StartPal, EndPal : Byte; Var Pallete : PalType);
{ Make colors from one side to the other with constant diference }
Procedure ramp(st,en,r1,g1,b1,r2,g2,b2 : byte);
{ Cycles the pallete beetwen StartPal and EndPal }
Procedure CyclePal(Up: Boolean; StartPal, EndPal : Byte; var Pallete : PalType);

Implementation

Uses Crt;

procedure WaitRetrace; assembler;
Asm
  Mov Dx,03Dah
  @P: In al,dx
  Test al,8
  Jz @P
End;

Procedure Pal(Col,R,G,B : Byte); Assembler;
asm
  mov    dx,3c8h
  mov    al,[col]
  out    dx,al
  inc    dx
  mov    al,[r]
  out    dx,al
  mov    al,[g]
  out    dx,al
  mov    al,[b]
  out    dx,al
end;

Procedure GetAllPal( Pallete : PalType); Assembler;
Asm
  Mov Al, $FF
  Mov DX, $C6
  Out DX, Al
  Mov DX, $3C7
  Mov Al, 0
  Out DX, Al
  Mov DX, $3C9
  Les di, Pallete
  Mov CX, 768
@B2:
  In Al, DX
  Mov ES:[di], Al
  Inc di
  Loop @B2
End;

Procedure SetAllPal( Pallete : PalType ); Assembler;
Asm
   push   ds
   lds    si, Pallete
   mov    dx, 3c8h
   mov    al, 0
   out    dx, al
   inc    dx
   mov    cx, 768
   rep    outsb
   pop    ds
End;

Procedure LoadPal (Fn : String; Pallete : PalType );
Var
  F : File;
Begin
  Assign (F, Fn);
  Reset (F, 1);
  If IOResult <> 0 then Exit;
  If FIlesize (F) < 768 then Exit;
  Blockread (F, Pallete, 768);
  Close (F);
End;

Procedure Fade2Pal( StartPal, EndPal, D : Word; Pallete : PalType);
Var
  Temp : PalType;
  Done : Boolean;
Begin
  GetAllPal(Temp);
  Repeat
    Delay(D);
    WaitRetrace;
    Done:=OneStepFade(StartPal, EndPal, Temp, Pallete);
  Until Done
End;

Function OneStepFade( StartPal, EndPal : Word; var CurrPal : PalType; Pallete : Paltype) : Boolean;
VAR
  Xc, Yc      : Byte;
  Temp        : Boolean;
BEGIN
  Temp:=True;
  For Xc:=StartPal To EndPal Do
    For Yc:=0 To 2 Do Begin
      If CurrPal[Xc,Yc]<Pallete[Xc,Yc] Then Begin Inc(CurrPal[Xc,Yc]); Temp:=False End;
      If CurrPal[Xc,Yc]>Pallete[Xc,Yc] Then Begin Dec(CurrPal[Xc,Yc]); Temp:=False End
  End;
  SetAllPal(CurrPal);
  OneStepFade:=Temp
End;

{ MaxTimes should be equal or greater than 63. }
Procedure StepFade( StartPal, EndPal, D, MaxTimes : Word; Pallete : PalType );
VAR
  Xc, Yc, Zc  : Byte;
  Temp, Temp2 : PalType;
BEGIN
  GetAllPal(Temp);
  For Xc:=StartPal To EndPal Do
    For Yc:=0 To 2 Do
      If Temp[Xc,Yc]<>Pallete[Xc,Yc] Then Temp2[Xc,Yc]:=MaxTimes Div Abs(Temp[Xc,Yc]-Pallete[Xc,Yc]);
  For Zc:=1 To MaxTimes Do Begin
    For Xc:=StartPal To EndPal Do
      For Yc:=0 To 2 Do Begin
        If (Temp[Xc,Yc]<Pallete[Xc,Yc]) And ((Zc Mod Temp2[Xc,Yc]<>0) Or (Temp2[Xc,Yc]=1)) Then Inc(Temp[Xc,Yc]);
        If (Temp[Xc,Yc]>Pallete[Xc,Yc]) And ((Zc Mod Temp2[Xc,Yc]<>0) Or (Temp2[Xc,Yc]=1)) Then Dec(Temp[Xc,Yc])
      End;
    Delay(D);
    WaitRetrace;
    SetAllPal(Temp)
  End;
  SetAllPal(Pallete)
End;

Procedure FillPalType(R,G,B : Word; Var Pallete : Paltype);
Var
  Count : Byte;
Begin
  For Count:=0 To 255 Do
    Begin
      Pallete[Count,0]:=R;
      Pallete[Count,1]:=G;
      Pallete[Count,2]:=B
    End
End;

Procedure SetGrayPal(StartPal, EndPal : Byte; Var Pallete : PalType);
Var
  Count : Byte;
Begin
  For Count:=StartPal To EndPal Do
    Begin
      Pallete[Count,0]:=(Pallete[Count,0]+Pallete[Count,1]+Pallete[Count,2]) Div 3;
      Pallete[Count,1]:=Pallete[Count,0];
      Pallete[Count,2]:=Pallete[Count,0]
    End
End;

Procedure SetRedPal(StartPal, EndPal : Byte; Var Pallete : PalType);
Var
  Count : Byte;
Begin
  For Count:=StartPal To EndPal Do
    Begin
      Pallete[Count,0]:=(Pallete[Count,0]+Pallete[Count,1]+Pallete[Count,2]) Div 3;
      Pallete[Count,1]:=0;
      Pallete[Count,2]:=0
    End
End;

Procedure SetGreenPal(StartPal, EndPal : Byte; Var Pallete : PalType);
Var
  Count : Byte;
Begin
  For Count:=StartPal To EndPal Do
    Begin
      Pallete[Count,0]:=0;
      Pallete[Count,1]:=(Pallete[Count,0]+Pallete[Count,1]+Pallete[Count,2]) Div 3;
      Pallete[Count,2]:=0
    End
End;

Procedure SetBluePal(StartPal, EndPal : Byte; Var Pallete : PalType);
Var
  Count : Byte;
Begin
  For Count:=StartPal To EndPal Do
    Begin
      Pallete[Count,0]:=0;
      Pallete[Count,1]:=0;
      Pallete[Count,2]:=(Pallete[Count,0]+Pallete[Count,1]+Pallete[Count,2]) Div 3
    End
End;

Procedure ramp(st,en,r1,g1,b1,r2,g2,b2 : byte);
Var
  rinc,ginc,binc : real;
  xc : byte;
Begin
  rinc:=(r2-r1)/(en-st+1);  ginc:=(g2-g1)/(en-st+1);  binc:=(b2-b1)/(en-st+1);
  For xc:= 1 to en-st+1 do
    Pal(xc+st-1,round(r1+rinc*xc),round(g1+ginc*xc),round(b1+binc*xc));
End;

Procedure CyclePal(Up: Boolean; StartPal, EndPal : Byte; var Pallete : PalType);
Var
  cR, cG, cB : Byte;
Begin
  If up
    Then Begin
           cR:= Pallete[EndPal][R];
           cG:= Pallete[EndPal][G];
           cB:= Pallete[EndPal][B];
           Move( Pallete[StartPal], Pallete[StartPal+1], (EndPal-StartPal)*3 );
           Pallete[StartPal][R]:= cR;
           Pallete[StartPal][G]:= cG;
           Pallete[StartPal][B]:= cB;
         End
    Else Begin
           cR:= Pallete[StartPal][R];
           cG:= Pallete[StartPal][G];
           cB:= Pallete[StartPal][B];
           Move( Pallete[StartPal+1], Pallete[StartPal], (EndPal-StartPal)*3 );
           Pallete[EndPal][R]:= cR;
           Pallete[EndPal][G]:= cG;
           Pallete[EndPal][B]:= cB;
         End
End;

End.

              Visit us at

              http://www.geocities.com/SiliconValley/Vista/1595/
              dark-cloud@geocities.com

