{
  襭 -ﬨ (।騬 楯窠)
}

const
  MAX_N = 50;
  FILE_IN = 'system.dat';
  FILE_OUT = 'system.sol';
var
  fin : Text;
  fout : Text;

  testNum : integer; {The number of test blocks}
  currTest : integer;

  n : integer;
  b : array[1..MAX_N] of integer; {Input data}

  x : array[1..MAX_N, 1..MAX_N] of boolean; {Graph matrix}
  s : array[1..MAX_N] of integer; {Current}
  Ans : boolean;

procedure ReadTestBlock;
var
  i : integer;
begin
  ReadLn(fin, n);
  for i:=1 to n do
    Read(fin, b[i]);
  FillChar(x, sizeof(x), false);
  FillChar(s, sizeof(s), 0);
  Ans := false;
end;

function SearchPathAndInvert(st : integer; var fin : integer) : boolean;
type
  TEdge = (WHITE, BLACK);
  TQueueElement = record
    vert : integer;
    lastEdge : TEdge;
    prev : integer;
  end;
var
  Queue : array[1..MAX_N*2] of TQueueElement;
  Visited : array[1..MAX_N, WHITE..BLACK] of boolean;
  maxInd : integer;
  currInd : integer;
  currVert : integer;
  currEdge : TEdge;
  neededEdge : TEdge;
  i : integer;
  v1, v2 : integer;
begin
  FillChar(Visited, sizeof(Visited), false);
  FillChar(Queue, sizeof(Queue), 0);
  Queue[1].vert := st;
  Queue[1].lastEdge := BLACK;
  Queue[1].prev := 0;
  currInd := 1;
  maxInd := 1;
  fin := 0;

  while (currInd <= maxInd) and (fin = 0) do
  begin
    currVert := Queue[currInd].vert;
    currEdge := Queue[currInd].lastEdge;
    if currEdge = BLACK then neededEdge := WHITE
                        else neededEdge := BLACK;
    for i:=1 to n do
      if i <> currVert then
        if ((i <> st) or (b[st]-s[st] > 1)) then
          if ((x[currVert, i]) xor (currEdge = BLACK)) then
            if (not Visited[i, neededEdge]) then
            begin
              Inc(maxInd);
              Queue[maxInd].vert := i;
              Queue[maxInd].lastEdge := neededEdge;
              Queue[maxInd].prev := currInd;
              Visited[i, neededEdge] := true;

              if ((neededEdge = WHITE) and (b[i]-s[i]>0)) then
              begin
                fin := i;
                break;
              end;
            end;
    Inc(currInd);
  end;

  if fin <> 0 then
  begin
    {Invert the path}
    currInd := maxInd;
    while Queue[currInd].prev <> 0 do
    begin
      v1 := Queue[currInd].vert;
      v2 := Queue[Queue[currInd].prev].vert;
      x[v1,v2] := not x[v1,v2];
      x[v2,v1] := not x[v2,v1];
      currInd := Queue[currInd].prev;
    end;
    SearchPathAndInvert := true;
  end else
  begin
    SearchPathAndInvert := false;
  end;
end;

function NextUnsatVert : integer;
var
  i : integer;
begin
  NextUnsatVert := 0;
  for i:=1 to n do
    if s[i] < b[i] then
    begin
      NextUnsatVert := i;
      break;
    end;
end;

procedure Proceed;
var
   startVert : integer;
   finVert : integer;
   pathFound : boolean;
begin
  startVert := NextUnsatVert;
  pathFound := true;
  while (startVert <> 0) and (pathFound) do
  begin
    pathFound := SearchPathAndInvert(startVert, finVert);
    if pathFound then
    begin
      Inc(s[startVert]);
      Inc(s[finVert]);
      startVert := NextUnsatVert;
    end;
  end;
  if startVert = 0 then
    Ans := true;
end;

procedure WriteAnswer;
var
  i, j : integer;
begin
  if Ans then
  begin
    for i:=1 to n do
      for j:=i+1 to n do
        if j = n then
          if x[i,n] then
            WriteLn(fout, '1')
          else
            WriteLn(fout, '0')
        else
          if x[i,j] then
            Write(fout, '1 ')
          else
            Write(fout, '0 ');
  end else
  begin
    WriteLn(fout, '-1');
  end;
end;

begin
  Assign(fin, FILE_IN);
  Reset(fin);
  Assign(fout, FILE_OUT);
  Rewrite(fout);
  Readln(fin, testNum);

  for currTest := 1 to testNum do
  begin
    ReadTestBlock;
    Proceed;
    WriteAnswer;
  end;

  Close(fout);
  Close(fin);
end.
